<?php
// (c)2006 Matteo Lucarelli
//XML load/store functions

require_once('config.php');
require_once('utils.php');
require_once("lang.php");

// tree management functions //////////////////////////////////////////////////

function cb_open_tree($parser, $tag, $attrs) {

	global $level,$tree;
	
	if ($tag=="NODE"){
		$attrs["LEVEL"]=$level++;
		$tree[]=$attrs;
	}
} 

function cb_close_tree($parser, $tag) { 

	global $level;
	if ($tag=="NODE") $level--;

}

function tree_load(){

	global $tree,$level,$section;
	
	$tree=array();
	$level=0;
	$loaded=TRUE;

	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler ( $parser, "cb_open_tree", "cb_close_tree" ); 
	if ($fp = @fopen(DATA_DIR.XML_TREE,'r')){
		while ($data = fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp)); 
		fclose($fp);
	}
	else $loaded=FALSE;
	xml_parser_free($parser);
	
	// load sections counter
	for ($i=0; $i<count($tree); $i++){
		if (section_load($tree[$i]['LINK'])) $tree[$i]['COUNT']=count($section);
		else $tree[$i]['COUNT']=0;
	}
	unset($section);
	return $loaded;
}

// delete directories not in tree nodes
function delete_old_dir($basedir){

	global $tree;
	$ret=true;

	if ($dh = opendir($basedir)) {
		while (($file = @readdir($dh)) !== false) {
			if ((@is_dir($basedir.$file))&&($file!=".")&&($file!="..")){
				$ret=$ret&&delete_old_dir($basedir.$file."/");
				$todel=TRUE;
				if ($tree) foreach ($tree as $item) 
					if ($basedir.$file==DATA_DIR.$item['LINK']) $todel=FALSE;
				if ($todel){
					if ($dh2 = @opendir($basedir.$file)){
						while (($file2 = readdir($dh2)) !== false)
							if (!is_dir($basedir.$file."/".$file2))
								if (!@unlink($basedir.$file."/".$file2)) $ret=false;
						closedir($dh2);
					}else $ret=false;
					if (!@rmdir($basedir.$file)) $ret=false;
				}
			}
		}
		closedir($dh);
	}
	return $ret;
}

function tree_save(){

	global $tree,$err_str;
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<tree>\n";
	
	$cl=-1;
	$links=build_links();
	
	for ($i=0;$i<count($tree);$i++){
			
		// close node-field and store level
		for (;$tree[$i]['LEVEL']<=$cl;$cl--)  $xml.="</node>\n";
		$cl=$tree[$i]['LEVEL'];
		
		// assegna un valore ai nuovi campi link
		// rinomina le cartelle modificate
		
		// TODO - verificare
		if ($tree[$i]['LINK']!='') {
			if ($tree[$i]['LEVEL']>0) $oldpath=substr($links[$i],0,strrpos($links[$i],"/")).strrchr($tree[$i]['LINK'],"/");
			else $oldpath=$tree[$i]['LINK'];
			if (($oldpath!=$links[$i])&&(file_exists(DATA_DIR.$oldpath))) 
				@rename(DATA_DIR.$oldpath,DATA_DIR.$links[$i]);
		}
		$tree[$i]['LINK']=$links[$i];
		
		// crea le nuove cartelle e gli xml
		$cpath=DATA_DIR.$tree[$i]['LINK'];
		if (!file_exists($cpath)) 
			if (!@mkdir($cpath)) $err_str= STR_ERR_SAVE ;
		
		// crea i nuovi xml
		if (!file_exists($cpath.'/'.XML_SECT)){
			if ($fp=@fopen($cpath.'/'.XML_SECT,'w')){
				fwrite($fp,"<?xml version='1.0' encoding='ISO-8859-1'?>\n");
				fclose($fp);
			}else $err_str = STR_ERR_SAVE;
		}
		
		$xml.= "<node label='".$tree[$i]['LABEL']."' link='".$tree[$i]['LINK']."'>\n";
	}
	for (;0<=$cl;$cl--)  $xml.="</node>\n";
	$xml.= "</tree>\n";
	
	if ($fp=@fopen(DATA_DIR.XML_TREE, 'w')){
		fwrite ($fp,$xml);
		fclose($fp);
	}else $err_str = STR_ERR_SAVE ;
	
	if (!delete_old_dir(DATA_DIR)) $err_str = STR_ERR_SAVE ;
}

// section management functions ///////////////////////////////////////////////

function cb_fake($parser, $tag) {}

function cb_open_section($parser, $tag, $attrs) {

	global $section,$descr,$cover,$showcover;
	
	if ($tag=="ITEM") $section[]=$attrs;
	if ($tag=="SECTION"){
		for ($i=0;$i<DESCR_COUNT;$i++) $descr[$i]=$attrs['DESCR'.$i];
		$cover=$attrs['COVER'];
		$showcover=$attrs['SHOWCOVER'];
	}
}

function section_load($path){

	global $section;
	
	$section=array();
	$loaded=TRUE;
	
	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler ( $parser, "cb_open_section", "cb_fake" );
	if ($fp = @fopen(DATA_DIR.$path.'/'.XML_SECT,'r')){
		while ($data = fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp));
		fclose($fp);
	}
	else $loaded=FALSE;
	xml_parser_free($parser);
	
	return $loaded;
}

function section_save($path,$files){

	global $section,$descr,$cover,$showcover,$err_str;

	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	
	$xml.= "<section cover='".$cover."' ";
	for ($i=0;$i<DESCR_COUNT;$i++) $xml.= "descr".$i."='".$descr[$i]."' ";
	$xml.= "showcover='".$showcover."'>\n";
	
	for ($i=0;$i<count($section);$i++){
		
		// carica i nuovi file
		if ($files["userfile$i"]['name']!=''){
		
			if ($files["userfile$i"]['error']!=0){
				$err_str = STR_ERR_SAVE . "(err: ".$files["userfile$i"]['error'].")";
				$ffs[$i]['ERRCH']="*";
			}
			
			$destinationname=strtolower(basename($files["userfile$i"]['name']));
			
			// build an alt-name for existing file name (Nfilename)
			if (file_exists(DATA_DIR.$path."/".$destinationname)){			
				$o=0;
				while (file_exists(DATA_DIR.$path."/".$o.$destinationname)) $o++;
				$destinationname=$o.$destinationname;
			}
			
			if (!@move_uploaded_file($files["userfile$i"]['tmp_name'],DATA_DIR.$path."/".$destinationname)){
				$err_str=STR_ERR_SAVE;
 				$section[$i]['ERRCH']="*";
			}
			else{	
				chmod(DATA_DIR.$path."/".$destinationname,0644);
				
				if (!create_thumb(DATA_DIR.$path."/".$destinationname,DATA_DIR.$path."/thumb.".$destinationname))
					$section[$i]['ERRCH']="*";
				else{
					if ($section[$i]['IMG']!=''){
						// cancella vecchia immagine e thumbnail
						@unlink(DATA_DIR.$path."/".$section[$i]['IMG']);
						@unlink(DATA_DIR.$path."/thumb.".$section[$i]['IMG']);
					}
					$section[$i]['IMG']=$destinationname;
				}
			}
		}
		$xml.= "<item label='".$section[$i]['LABEL']."' text='".$section[$i]['TEXT']."' img='".$section[$i]['IMG']."' />\n";
	}
	$xml.= "</section>\n";
	
	if (USE_COVER_THUMB&&($section[$cover]['IMG']!='')){
		if (!create_thumb(DATA_DIR.$path."/".$section[$cover]['IMG'],DATA_DIR.$path."/index.jpg",COVER_THUMB_MAXW,COVER_THUMB_MAXH))
				$section[$i]['ERRCH']="*";
	}
	
	if ($fp = @fopen(DATA_DIR.$path.'/'.XML_SECT, 'w')){
		fwrite ($fp,$xml);
		fclose($fp);
	}else $err_str=STR_ERR_SAVE;
	
	// cancella i file non più in lista
	if ($dh = opendir(DATA_DIR.$path)) {
		while (($file = readdir($dh)) !== false) {
			if ((!is_dir(DATA_DIR.$path."/".$file))&&($file!=XML_SECT)){
				$todel=TRUE;
				if ((USE_COVER_THUMB)&&($file=="index.jpg")) $todel=FALSE;
				foreach ($section as $item) 
					if (($item['IMG']==$file)||("thumb.".$item['IMG']==$file)){
						$todel=FALSE;
						break;
					}	
				if ($todel){
					@unlink(DATA_DIR.$path."/".$file);
					@unlink(DATA_DIR.$path."/thumb.".$file);
				}
			}
		}
		closedir($dh);
	}
}

// option management functions /////////////////////////////////////////////////

function cb_open_opt($parser, $tag, $attrs) {

	global $opt;
	if ($tag=="ITEM") $opt[]=$attrs;
}

function opt_load($optname){

	global $opt;
	
	$opt=Array();
	$loaded=TRUE;
	
	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler ( $parser, "cb_open_opt", "cb_fake" ); 
	if ($fp = @fopen(DATA_DIR.strtolower($optname).".xml",'r')){
		while ($data = fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp)); 
		fclose($fp);
	}
	else $loaded=FALSE;
	xml_parser_free($parser);
	
	return $loaded;
}

function opt_save($optname){

	global $opt;

	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<".strtolower($optname).">\n";
	
	for ($i=0;$i<count($opt);$i++)		
		$xml.= "<item label='".$opt[$i]['LABEL']."' text='".$opt[$i]['TEXT']."' link='".$opt[$i]['LINK']."' />\n";
		
	$xml.= "</".strtolower($optname).">\n";
	
	$fp = fopen(DATA_DIR.strtolower($optname).".xml",'w');
	fwrite ($fp,$xml);
	fclose($fp);
}

// fixed files functions /////////////////////////////////////////////////

function fix_save($files,$todel){

	global $ffs,$err_str;
	
	for ($i=0;$i<count($ffs);$i++){
		
		if ($todel[$i]=='on') unlink(DATA_DIR.$ffs[$i]['path']);
	
		if ($files["userfile$i"]['name']!=''){
			if ($files["userfile$i"]['error']!=0){
				$err_str=STR_ERR_SAVE."(err: ".$files["userfile$i"]['error'].")";
				$ffs[$i]['ERRCH']="*";
				return;
			}
			if (!@move_uploaded_file($files["userfile$i"]['tmp_name'],DATA_DIR.$ffs[$i]['path'])){
				$err_str=STR_ERR_SAVE;
 				$ffs[$i]['ERRCH']="*";
 				return;
			}
			else chmod(DATA_DIR.$ffs[$i]['path'],0644);
		}
	}
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<files>\n";

	for ($i=0;$i<count($ffs);$i++)
		if (@stat(DATA_DIR.$ffs[$i]['path']))
			$xml.= "\t<item path='".$ffs[$i]['path']."' />\n";
	
	$xml.= "</files>\n";

	if ($fp=@fopen(DATA_DIR.XML_FXFILES, 'w')){
		fwrite ($fp,$xml);
		fclose($fp);
	}else $err_str = STR_ERR_SAVE ;
}

?>
