<?php
// (c)2006 Matteo Lucarelli
// utility and validation functions

// delete some XML-cracking chars
function clean_label($str){

	$str = strtr($str, array("&" => "&amp;" , "'" => "&#039;" , ">" => "&gt;" , "<" => "&lt;" , chr(34) => "&quot;" , "\\" => ""));
	return trim($str);
}

// delete all the "problematics" chars
function clean_link($str){

	$str = strtr($str,"\xC0\xC1\xC2\xC3\xC4\xC5\xC6","AAAAAAA");
	$str = strtr($str,"\xC7","C");
	$str = strtr($str,"\xC8\xC9\xCA\xCB","EEEE");
	$str = strtr($str,"\xCC\xCD\xCE\xCF","IIII");
	$str = strtr($str,"\xD1","N");
	$str = strtr($str,"\xD2\xD3\xD4\xD5\xD6\xD8","OOOOOO");
	$str = strtr($str,"\xDD","Y");
	$str = strtr($str,"\xDF","S");
	$str = strtr($str,"\xE0\xE1\xE2\xE3\xE4\xE5\xE6","aaaaaaa");
	$str = strtr($str,"\xE7","c");
	$str = strtr($str,"\xE8\xE9\xEA\xEB","eeee");
	$str = strtr($str,"\xEC\xED\xEE\xEF","iiii");
	$str = strtr($str,"\xF1","n");
	$str = strtr($str,"\xF2\xF3\xF4\xF5\xF6\xF8","oooooo");
	$str = strtr($str,"\xF9\xFA\xFB\xFC","uuuu");
	$str = strtr($str,"\xFD\xFF","yy");
	
	$str=strtolower($str);
	$str = strtr($str, array("&"  => "e", 
	                         "'"  => " ",  
	                         "/"  => "_", 
	                         "\\" => "_",  
	                         ":"  => "_", 
	                         "*"  => "_",
	                         "?"  => "_", 
	                         "\"" => "_",
	                         "<"  => "_", 
	                         ">"  => "_",
	                         "|"  => "_", 
	                         " "  => "_",
	                         "#"  => " ")
	            );
	return $str;
}

// convert in bytes the PHP notation K|M|G
function return_bytes($val) {

	$val = trim($val);
	$last = strtolower($val{strlen($val)-1});
	switch($last) {
		// The 'G' modifier is available since PHP 5.1.0
		case 'g':
		        $val *= 1024;
		case 'm':
		        $val *= 1024;
		case 'k':
		        $val *= 1024;
	}
	return $val;
}

// convert the PHP notation K|M|G in bytes 
function return_notation_bytes($val,$decimaldig) {

	if ($val>1073741824) return number_format(($val/1073741824),$decimaldig)."G";
	else if ($val>1048576) return number_format(($val/1048576),$decimaldig)."M";
	else if ($val>1024) return number_format(($val/1024),$decimaldig)."K";	
	return number_format($val,$decimaldig);
}

// build arry if section paths
function build_links()
{
	$cl=0;
	$links=Array();
	global $tree;
	
	for ($i=0;$i<count($tree);$i++){
		
		if ($tree[$i]['LEVEL']==0) $path=clean_link($tree[$i]['LABEL']);
		else if ($tree[$i]['LEVEL']>$cl) $path .= "/".clean_link($tree[$i]['LABEL']);
		else{
			for (;$tree[$i]['LEVEL']<=$cl;$cl--) $path = dirname($path);
			$path .= "/".clean_link($tree[$i]['LABEL']);
		}
		$cl=$tree[$i]['LEVEL'];
		$links[$i]=$path;
	}
	
	return $links;
}

// thumbnails generator
// THUMB_GEN: I=imagemagik | L=libgd
function create_thumb($imagefile, $thumbfile, $maxw=THUMB_MAXW, $maxh=THUMB_MAXH) {

	global $err_str;

	if (THUMB_GEN=="I") {
	
		if (THUMB_MODE=="R"){
			system("\"".IMGMGK_PATH."convert\" -geometry ".$maxw."x".$maxh." \"$imagefile\" \"$thumbfile\"",$ret);
		}else{
			$imageinfo=getimagesize($imagefile);
			$x=(int)($imageinfo[0]/2-$maxw/2);
			$y=(int)($imageinfo[1]/2-$maxh/2);
			system("\"".IMGMGK_PATH."convert\" -crop ".$maxw."x".$maxh."+".$x."+".$y." \"$imagefile\" \"$thumbfile\"",$ret);
			echo "\"".IMGMGK_PATH."convert\" -crop ".$maxw."x".$maxh."+".$x."+".$y." \"$imagefile\" \"$thumbfile\"";
		}
		if ($ret!=0){		
			$err_str = STR_ERR_THUMB;
			return FALSE;
		}
		return true;
	} else if (THUMB_GEN=="L") {
	
		// need libgd support in PHP - gif jpg and png are supported
		$imageinfo=getimagesize($imagefile);
		if (!$imageinfo) return FALSE;
		switch ($imageinfo[2]) {
			case 1:
				$imagecreator = "imagecreatefromgif";
				break;
			case 2:
				$imagecreator = "imagecreatefromjpeg";
				break;
			case 3:
				$imagecreator = "imagecreatefrompng";
				break;
			default:
				$err_str= STR_ERR_THUMB;
				return FALSE;
		}
		if (!function_exists($imagecreator)){
				$err_str = STR_ERR_THUMB;
				return FALSE;		
		}
		$src_img=$imagecreator($imagefile);
		
		if (THUMB_MODE=="R"){
			$thumbw = min( $maxw, (int) ( $imageinfo[0] / $imageinfo[1] * $maxh + 0.5));
			$thumbh = min( $maxh, (int) ( $imageinfo[1] / $imageinfo[0] * $maxw + 0.5));
			$dst_img = imagecreatetruecolor($thumbw, $thumbh);
			imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $thumbw, $thumbh, $imageinfo[0], $imageinfo[1]);
		}else{
			$dst_img = imagecreatetruecolor($maxw, $maxh);
			imagecopy($dst_img, $src_img, 0, 0, (int)(($imageinfo[0]+$maxw)/2), (int)(($imageinfo[1]+$maxh)/2), $maxw, $maxh);
		}
		
		$ext=strtolower(strchr($imagefile,"."));
		if ($ext=="gif") imagegif($dst_img, $thumbfile);
		else if (($ext=="jpg")||("jpeg")) imagejpeg($dst_img, $thumbfile);
		else if ($ext=="png") imagepng($dst_img, $thumbfile);
		imagedestroy($dst_img);
		return TRUE;
	}
	$err_str = STR_ERR_THUMB;
	return FALSE;
}

// (C) bobbfwed at comcast dot net
// move a directory and all subdirectories and files (recursive)
// void dirmv( str 'source directory', str 'destination directory' [, bool 'overwrite existing files' [, str 'location within the directory (for recurse)']] )
function dirmv($source, $dest, $overwrite = false, $funcloc = NULL){

	if(is_null($funcloc)){
		$dest .= '/' . strrev(substr(strrev($source), 0, strpos(strrev($source), '/')));
		$funcloc = '/';
	}

	if(!is_dir($dest . $funcloc))
		mkdir($dest . $funcloc); // make subdirectory before subdirectory is copied

	if($handle = opendir($source . $funcloc)){ // if the folder exploration is sucsessful, continue
		while(false !== ($file = readdir($handle))){ // as long as storing the next file to $file is successful, continue
			if($file != '.' && $file != '..'){
				$path  = $source . $funcloc . $file;
				$path2 = $dest . $funcloc . $file;

				if(is_file($path)){
					if(!is_file($path2)){
						if(!@rename($path, $path2)){
							echo '<font color="red">File ('.$path.') could not be moved, likely a permissions problem.</font>';
						}
					} elseif($overwrite){
						if(!@unlink($path2)){
							echo 'Unable to overwrite file ("'.$path2.'"), likely to be a permissions problem.';
					} else
						if(!@rename($path, $path2)){
							echo '<font color="red">File ('.$path.') could not be moved while overwritting, likely a permissions problem.</font>';
						}
					}
				} elseif(is_dir($path)){
					dirmv($source, $dest, $overwrite, $funcloc . $file . '/'); //recurse!
					rmdir($path);
				}
			}
		}
		closedir($handle);
	}
}

?>
